/**
 * Ce sketch Arduino est destin  tre utilis avec une tlcommande sur liaison srie
 * qui envoit sur la liaison srie 3 octets : 
 * - 0xFF
 * - vitesse gauche (entre -100 et +100)
 * - vitesse droite (entre -100 et +100)
 */

#include <Servo.h>

// constantes indiquant la position (en degrs) neutre (roue immobile)
//  ajuster pour chacune des roues et chacun des robots
#define NEUTRE_G  76
#define NEUTRE_D  77

// nombre de vitesses autour du neutre
#define VAR  5

Servo servG;
Servo servD;

// vitesses (entre -100 et 100)
int vg;
int vd;

void setup()
{
  // communication srie
  Serial.begin(9600);
  Serial.println("> Connection to Pobot Easy granted.");
  // connecter les servomoteurs
  servG.attach(10);
  servD.attach(9);
  // arrter le robot
  servG.write(NEUTRE_G);
  servD.write(NEUTRE_D);
  // initialiser les vitesses
  vg = 0;
  vd = 0;    
}

void loop()
{
  // mise  jour des vitesses
  if (Serial.available() >= 3)
  {    
    if (Serial.read() != 0xFF) 
    {
      Serial.println("Erreur de rception !!");
      Serial.flush();
      return;      
    }
    vg = Serial.read();
    vd = Serial.read();
    // rtablir les valeurs signes
    if (vg >= 128) {
      vg = vg-255;      
    }   
    if (vd >= 128) {
      vd = vd-255;  
    }
    // afficher les valeurs reues    
    Serial.print(vg,DEC);
    Serial.print(",");
    Serial.print(vd,DEC);
    Serial.println();    
    // commander les servomoteurs  
    servG.write(NEUTRE_G+vg*VAR/100.0);
    servD.write(NEUTRE_D-vd*VAR/100.0);
    Serial.flush();
  }
  delay(20);
}

